/*
 * Exemple simple d'utilisation des threads
 *
 * Un tutoriel plus complet en Anglais est disponible sur
 * https://computing.llnl.gov/tutorials/pthreads/
 */

#include <pthread.h> /* pour les fonctions pthread */
#include <stdio.h>
#include <unistd.h>
#include <stdint.h> /* pour intptr_t */

/* Fonction exécutée en parallèle par les deux threads */
void *f(void *parametre) {
	/* Récupérer le paramètre du thread, pour convertir en int il faut
	 * passer par l'entier intptr_t qui a la même taille qu'un pointeur */
	int n = (intptr_t) parametre;

	int i;
	/* Chacun imprime 5 ou 10 fois */
	for (i = 0; i < n*5; i++) {
		fprintf(stderr,"je suis le thread %d\n", n);
		sleep(1);
	}

	/* Et termine */
	return NULL;
}

/* Thread principal */
int main(void) {
	pthread_t t1, t2;

	/* Créer deux threads */
	pthread_create(&t1, NULL, f, (void*)(intptr_t) 1);
	pthread_create(&t2, NULL, f, (void*)(intptr_t) 2);
	fprintf(stderr,"main a fini de créer !\n");

	/* Les threads commencent à s'exécuter en parallèle */
	sleep(1);
	fprintf(stderr,"je suis le thread principal\n");
	sleep(1);

	fprintf(stderr,"le thread principal attend les autres\n");
	/* On attend la terminaison du premier */
	pthread_join(t1, NULL);
	fprintf(stderr,"t1 a fini !\n");

	/* On attend la terminaison du second */
	pthread_join(t2, NULL);
	fprintf(stderr,"t2 a fini !\n");

	return 0;
}
